/**************************************************************
 * HTTPPrint.h
 * Provides callback headers and resolution for user's custom
 * HTTP Application.
 * 
 * This file is automatically generated by the MPFS Utility
 * ALL MODIFICATIONS WILL BE OVERWRITTEN BY THE MPFS GENERATOR
 **************************************************************/

#ifndef __HTTPPRINT_H
#define __HTTPPRINT_H

#include "TCPIP Stack/TCPIP.h"

#if defined(STACK_USE_HTTP2_SERVER)

extern HTTP_STUB httpStubs[MAX_HTTP_CONNECTIONS];
extern BYTE curHTTPID;

void HTTPPrint(DWORD callbackID);
void HTTPPrint_hellomsg(void);
void HTTPPrint_config_mac(void);
void HTTPPrint_config_dhcpchecked(void);
void HTTPPrint_config_ip(void);
void HTTPPrint_config_gw(void);
void HTTPPrint_config_subnet(void);
void HTTPPrint_config_dns1(void);
void HTTPPrint_config_dns2(void);
void HTTPPrint_reboot(void);
void HTTPPrint_rebootaddr(void);
void HTTPPrint_server_name(void);
void HTTPPrint_NodeName(void);
void HTTPPrint_delay_time(void);
void HTTPPrint_time_out(void);
void HTTPPrint_keep_alive(void);
void HTTPPrint_jittter_size(void);
void HTTPPrint_RX_AutoPolarity(void);
void HTTPPrint_TX_Polarity(void);
void HTTPPrint_COS_Check(void);
void HTTPPrint_SN_Squelch(void);
void HTTPPrint_CRC_Check(void);
void HTTPPrint_LastFrame(void);
void HTTPPrint_HeaderGen(void);
void HTTPPrint_HeaderGenType(void);
void HTTPPrint_HalfFull(void);
void HTTPPrint_RX_Polarity(void);
void HTTPPrint_NtpName(void);
void HTTPPrint_TimeZone(void);
void HTTPPrint_CurDate(void);
void HTTPPrint_CurTime(void);
void HTTPPrint_CurPTT(void);
void HTTPPrint_CurCOS(void);
void HTTPPrint_CurSSN(void);
void HTTPPrint_CurUser(void);
void HTTPPrint_user_id(void);
void HTTPPrint_user_pass(void);
void HTTPPrint_user_passC(void);
void HTTPPrint_TimeZoneMinutes(void);
void HTTPPrint_JitterSize(void);
void HTTPPrint_BeaconM(void);
void HTTPPrint_BeaconIntv(void);
void HTTPPrint_HeaderRep(void);
void HTTPPrint_alt_mycall(void);
void HTTPPrint_alt_mycall2(void);
void HTTPPrint_alt_yourcall(void);
void HTTPPrint_alt_rpt1call(void);
void HTTPPrint_alt_rpt2call(void);
void HTTPPrint_flag7(void);
void HTTPPrint_flag6(void);
void HTTPPrint_flag5(void);
void HTTPPrint_flag4(void);
void HTTPPrint_flag3(void);
void HTTPPrint_flag2(void);
void HTTPPrint_flag1(void);
void HTTPPrint_flag0(void);
void HTTPPrint_a_mycall(void);
void HTTPPrint_a_mycall2(void);
void HTTPPrint_a_yourcall(void);
void HTTPPrint_a_rpt1call(void);
void HTTPPrint_a_rpt2call(void);
void HTTPPrint_Aflag(void);
void HTTPPrint_RefName(void);
void HTTPPrint_auth_call(void);
void HTTPPrint_pin(void);
void HTTPPrint_RefSelect(void);
void HTTPPrint_BandSelect(void);
void HTTPPrint_ReConnect(void);
void HTTPPrint_ConnectUser(void);
void HTTPPrint_BeaconCall(void);
void HTTPPrint_Repeater(void);
void HTTPPrint_DisableRFcmd(void);
void HTTPPrint_AutConnect(void);
void HTTPPrint_CurRef(void);
void HTTPPrint_Notice(void);
void HTTPPrint_DateTime(void);
void HTTPPrint_VoiceMsg(void);
void HTTPPrint_http(void);
void HTTPPrint_uploaded(void);
void HTTPPrint_access(void);
void HTTPPrint_dprsip(void);
void HTTPPrint_dprsport(void);
void HTTPPrint_dprscall(void);
void HTTPPrint_dstarid(void);
void HTTPPrint_dprsvalid(void);
void HTTPPrint_DPRS_checked(void);
void HTTPPrint_dprsRadio(void);
void HTTPPrint_dprsInet(void);
void HTTPPrint_CurAPRS(void);
void HTTPPrint_plat(void);
void HTTPPrint_plong(void);
void HTTPPrint_pcomment(void);
void HTTPPrint_destination(void);
void HTTPPrint_mesgBody(void);
void HTTPPrint_dprsAutoLink(void);
void HTTPPrint_clientID(void);
void HTTPPrint_smtpserver(void);
void HTTPPrint_smtpport(void);
void HTTPPrint_smtp_auth(void);
void HTTPPrint_smtpuser(void);
void HTTPPrint_smtppass(void);
void HTTPPrint_EmailAccess(void);
void HTTPPrint_RefSelectFirst(void);
void HTTPPrint_accessFirst(void);
void HTTPPrint_EmailAccessFirst(void);
void HTTPPrint_pinterval(void);
void HTTPPrint_ack(void);
void HTTPPrint_DebugSwitch(void);
void HTTPPrint_altdstarid(void);
void HTTPPrint_orgSSID(void);
void HTTPPrint_altSSID(void);
void HTTPPrint_sendercall(void);
void HTTPPrint_LastMsg(void);
void HTTPPrint_dprsAutoReLink(void);
void HTTPPrint_ircDDB(void);
void HTTPPrint_ircDDBtype(void);
void HTTPPrint_ircSelect(void);
void HTTPPrint_irc_ref(void);
void HTTPPrint_ircBandSelect(void);

void HTTPPrint(DWORD callbackID)
{
	switch(callbackID)
	{
        case 0x00000001:
			HTTPPrint_hellomsg();
			break;
        case 0x00000002:
			HTTPIncFile((ROM BYTE*)"footer.inc");
			break;
        case 0x00000025:
			HTTPPrint_config_mac();
			break;
        case 0x00000027:
			HTTPPrint_config_dhcpchecked();
			break;
        case 0x00000028:
			HTTPPrint_config_ip();
			break;
        case 0x00000029:
			HTTPPrint_config_gw();
			break;
        case 0x0000002a:
			HTTPPrint_config_subnet();
			break;
        case 0x0000002b:
			HTTPPrint_config_dns1();
			break;
        case 0x0000002c:
			HTTPPrint_config_dns2();
			break;
        case 0x0000002d:
			HTTPPrint_reboot();
			break;
        case 0x0000002e:
			HTTPPrint_rebootaddr();
			break;
        case 0x00000033:
			HTTPIncFile((ROM BYTE*)"header.inc");
			break;
        case 0x0000004a:
			HTTPPrint_server_name();
			break;
        case 0x0000004e:
			HTTPPrint_NodeName();
			break;
        case 0x00000051:
			HTTPPrint_delay_time();
			break;
        case 0x00000052:
			HTTPPrint_time_out();
			break;
        case 0x00000053:
			HTTPPrint_keep_alive();
			break;
        case 0x00000054:
			HTTPPrint_jittter_size();
			break;
        case 0x00000055:
			HTTPPrint_RX_AutoPolarity();
			break;
        case 0x00000056:
			HTTPPrint_TX_Polarity();
			break;
        case 0x00000057:
			HTTPPrint_COS_Check();
			break;
        case 0x00000058:
			HTTPPrint_SN_Squelch();
			break;
        case 0x00000059:
			HTTPPrint_CRC_Check();
			break;
        case 0x0000005a:
			HTTPPrint_LastFrame();
			break;
        case 0x0000005b:
			HTTPPrint_HeaderGen();
			break;
        case 0x0000005c:
			HTTPPrint_HeaderGenType();
			break;
        case 0x0000005d:
			HTTPPrint_HalfFull();
			break;
        case 0x0000005e:
			HTTPPrint_RX_Polarity();
			break;
        case 0x00000060:
			HTTPPrint_NtpName();
			break;
        case 0x00000061:
			HTTPPrint_TimeZone();
			break;
        case 0x00000063:
			HTTPPrint_CurDate();
			break;
        case 0x00000064:
			HTTPPrint_CurTime();
			break;
        case 0x00000066:
			HTTPPrint_CurPTT();
			break;
        case 0x00000067:
			HTTPPrint_CurCOS();
			break;
        case 0x00000068:
			HTTPPrint_CurSSN();
			break;
        case 0x00000069:
			HTTPPrint_CurUser();
			break;
        case 0x0000006a:
			HTTPPrint_user_id();
			break;
        case 0x0000006b:
			HTTPPrint_user_pass();
			break;
        case 0x0000006c:
			HTTPPrint_user_passC();
			break;
        case 0x0000006d:
			HTTPPrint_TimeZoneMinutes();
			break;
        case 0x0000006e:
			HTTPPrint_JitterSize();
			break;
        case 0x00000071:
			HTTPPrint_BeaconM();
			break;
        case 0x00000072:
			HTTPPrint_BeaconIntv();
			break;
        case 0x00000073:
			HTTPPrint_HeaderRep();
			break;
        case 0x00000074:
			HTTPPrint_alt_mycall();
			break;
        case 0x00000075:
			HTTPPrint_alt_mycall2();
			break;
        case 0x00000076:
			HTTPPrint_alt_yourcall();
			break;
        case 0x00000077:
			HTTPPrint_alt_rpt1call();
			break;
        case 0x00000078:
			HTTPPrint_alt_rpt2call();
			break;
        case 0x00000079:
			HTTPPrint_flag7();
			break;
        case 0x0000007a:
			HTTPPrint_flag6();
			break;
        case 0x0000007b:
			HTTPPrint_flag5();
			break;
        case 0x0000007c:
			HTTPPrint_flag4();
			break;
        case 0x0000007d:
			HTTPPrint_flag3();
			break;
        case 0x0000007e:
			HTTPPrint_flag2();
			break;
        case 0x0000007f:
			HTTPPrint_flag1();
			break;
        case 0x00000080:
			HTTPPrint_flag0();
			break;
        case 0x00000081:
			HTTPPrint_a_mycall();
			break;
        case 0x00000082:
			HTTPPrint_a_mycall2();
			break;
        case 0x00000083:
			HTTPPrint_a_yourcall();
			break;
        case 0x00000084:
			HTTPPrint_a_rpt1call();
			break;
        case 0x00000085:
			HTTPPrint_a_rpt2call();
			break;
        case 0x00000088:
			HTTPPrint_Aflag();
			break;
        case 0x0000008a:
			HTTPPrint_RefName();
			break;
        case 0x0000008b:
			HTTPPrint_auth_call();
			break;
        case 0x0000008c:
			HTTPPrint_pin();
			break;
        case 0x0000008d:
			HTTPPrint_RefSelect();
			break;
        case 0x00000099:
			HTTPPrint_BandSelect();
			break;
        case 0x0000009a:
			HTTPPrint_ReConnect();
			break;
        case 0x0000009d:
			HTTPPrint_ConnectUser();
			break;
        case 0x0000009f:
			HTTPPrint_BeaconCall();
			break;
        case 0x000000a0:
			HTTPPrint_Repeater();
			break;
        case 0x000000a1:
			HTTPPrint_DisableRFcmd();
			break;
        case 0x000000a2:
			HTTPPrint_AutConnect();
			break;
        case 0x000000a3:
			HTTPPrint_CurRef();
			break;
        case 0x000000a5:
			HTTPPrint_Notice();
			break;
        case 0x000000a6:
			HTTPPrint_DateTime();
			break;
        case 0x000000a7:
			HTTPPrint_VoiceMsg();
			break;
        case 0x000000a8:
			HTTPPrint_http();
			break;
        case 0x000000a9:
			HTTPPrint_uploaded();
			break;
        case 0x000000aa:
			HTTPPrint_access();
			break;
        case 0x000000ac:
			HTTPPrint_dprsip();
			break;
        case 0x000000ad:
			HTTPPrint_dprsport();
			break;
        case 0x000000ae:
			HTTPPrint_dprscall();
			break;
        case 0x000000af:
			HTTPPrint_dstarid();
			break;
        case 0x000000b0:
			HTTPPrint_dprsvalid();
			break;
        case 0x000000b1:
			HTTPPrint_DPRS_checked();
			break;
        case 0x000000b2:
			HTTPPrint_dprsRadio();
			break;
        case 0x000000b3:
			HTTPPrint_dprsInet();
			break;
        case 0x000000b4:
			HTTPPrint_CurAPRS();
			break;
        case 0x000000b5:
			HTTPPrint_plat();
			break;
        case 0x000000b6:
			HTTPPrint_plong();
			break;
        case 0x000000b7:
			HTTPPrint_pcomment();
			break;
        case 0x000000b8:
			HTTPPrint_destination();
			break;
        case 0x000000b9:
			HTTPPrint_mesgBody();
			break;
        case 0x000000ba:
			HTTPPrint_dprsAutoLink();
			break;
        case 0x000000bb:
			HTTPPrint_clientID();
			break;
        case 0x000000bc:
			HTTPPrint_smtpserver();
			break;
        case 0x000000bd:
			HTTPPrint_smtpport();
			break;
        case 0x000000be:
			HTTPPrint_smtp_auth();
			break;
        case 0x000000bf:
			HTTPPrint_smtpuser();
			break;
        case 0x000000c0:
			HTTPPrint_smtppass();
			break;
        case 0x000000c1:
			HTTPPrint_EmailAccess();
			break;
        case 0x000000c2:
			HTTPPrint_RefSelectFirst();
			break;
        case 0x000000c3:
			HTTPPrint_accessFirst();
			break;
        case 0x000000c4:
			HTTPPrint_EmailAccessFirst();
			break;
        case 0x000000c5:
			HTTPPrint_pinterval();
			break;
        case 0x000000c8:
			HTTPPrint_ack();
			break;
        case 0x000000c9:
			HTTPPrint_DebugSwitch();
			break;
        case 0x000000ca:
			HTTPPrint_altdstarid();
			break;
        case 0x000000cb:
			HTTPPrint_orgSSID();
			break;
        case 0x000000cc:
			HTTPPrint_altSSID();
			break;
        case 0x000000cd:
			HTTPPrint_sendercall();
			break;
        case 0x000000ce:
			HTTPPrint_LastMsg();
			break;
        case 0x000000cf:
			HTTPPrint_dprsAutoReLink();
			break;
        case 0x000000d0:
			HTTPPrint_ircDDB();
			break;
        case 0x000000d1:
			HTTPPrint_ircDDBtype();
			break;
        case 0x000000d2:
			HTTPPrint_ircSelect();
			break;
        case 0x000000d3:
			HTTPPrint_irc_ref();
			break;
        case 0x000000d4:
			HTTPPrint_ircBandSelect();
			break;
		default:
			// Output notification for undefined values
			TCPPutROMArray(sktHTTP, (ROM BYTE*)"!DEF", 4);
	}

	return;
}

void HTTPPrint_(void)
{
	TCPPut(sktHTTP, '~');
	return;
}

#endif

#endif
